#ifndef ROLL_QUEUES_H
#define ROLL_QUEUES_H
#include <vector>
#include <map>
#include "deparrqueues.h"
#include "arrivalchain.h"

//using Pair = std::pair<int, int>;


class UntransitionedQueues{
    int capacity;
    int size;
    int start; // where in the vector the queues start
    int end; // where in the vector the queues end
    int extra_in_begin; // to which index start corresponds
    std::vector<DepArrQueues> queues;  
    
    int getRightIndex(int second);
    bool isIndexIn( int index);
public:
    UntransitionedQueues(int max_length, int capacity, int begin_with);
    void printQueues(int second, bool throw_if_out_of_range = true);
//     void printKeys(int second);
    void printTotalProbability(int second);
    
    void addQueues(int second, DepArrQueues & new_queues);
    void deleteOldQueues();
    
    void removeMiddleParts(int second, int step);
    void removeMiddlePart(int second, Pair d_key, int a_ind, int m_down, int m_up);
    void addDownstreamPartsOfQueues(int second, int downstream_second, DepArrQueues& new_queues);
    void addMiddleAndUpstreamPartsWithCoef(int second, int downstream_second, DepArrQueues& new_queues, 
                                           std::map<char, double>& untransitioned_probs, std::map<char, double>& untransitioned_full_probs);
    
    DepArrQueues& operator[](int second);
    double getAlmostFullProbability(int second, char a_key);
    bool checkTotalProbability();
    bool checkUntransitioned(int second, ArrivalChain & arrival_chain);
    bool checkAllUntransitioned(int second, ArrivalChain & arrival_chain);
    double getTotalProbability();
    
    double getTotalUntransitionedQueue(int second, int downstream_second, char a_key);
    
    double getProbabilityBefore(int second);
    int getQueuesSize(); // NOT = size!
    
    bool hasSecond(int second);
    void removeDepartureStates(const std::vector<Pair> & d_keys_to_remove);
    
    void redirectZeroProbabilityTo(int second, Pair d_zero);
    
    std::map<Pair, double> getAlmostFullDKeys(int second, char a_key);
};

#endif // ROLL_QUEUES_H
