#ifndef TRANSITIONS_H
#define TRANSITIONS_H
#include <map>
#include "general.h"

// struct DKey{
//     int t;  // time t_g, t_r or t_u
//     int k;  // the number of delayed departures so far or -1 for red time
// };


template <class type>

class Transitions{
    std::map<type, double> transitions;
public:
    Transitions(){}
    void addTransition(type key, double value);
    double addDefaultTransition(type key_to, double value);  // add default transition to key_to so that the total transitioned flow is equal to value
    void redirectTransition(type key1, type key2, double prob);
    void rebalanceTransitions(type default_key, double prob_was, double prob_removed);
    void printTransitions();
    bool checkTransitions(double total);
    std::map<type, double> getTransitions() { return transitions; }
    bool hasKey(type key) { return isInMap(transitions, key); }
    double getTransition(type key) { return (isInMap(transitions, key)) ? transitions[key] : 0; }
    std::map< type, double > getNormalisedTransitions(double state_probability);
    double getTotalTransitionProbability();
    void addTransitions(std::map<type, double> & to_add);
    void removeTransition(type key) { transitions.erase(key); }
};

#endif // TRANSITIONS_H
